commit d1371dbe12214895cda0b13bfc6ff0ed9cbce15d
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Sat Apr 4 00:35:41 2020 +0200

    openmp: Fix ICE on #pragma omp parallel master in template [PR94477]
    
    The following testcase ICEs, because for parallel combined with some
    other construct we initialize the omp_parallel_combined_clauses pointer
    and expect the construct combined with it to clear it after it no longer
    needs it, but OMP_MASTER didn't do that.
    
    2020-04-04  Jakub Jelinek  <jakub@redhat.com>
    
            PR c++/94477
            * pt.c (tsubst_expr) <case OMP_MASTER>: Clear
            omp_parallel_combined_clauses.
    
            * g++.dg/gomp/pr94477.C: New test.

diff --git a/gcc/cp/ChangeLog b/gcc/cp/ChangeLog
index 324e133a125..ae33956b867 100644
--- a/gcc/cp/ChangeLog
+++ b/gcc/cp/ChangeLog
@@ -1,6 +1,12 @@
 2020-04-07  Jakub Jelinek  <jakub@redhat.com>
 
 	Backported from mainline
+	2020-04-04  Jakub Jelinek  <jakub@redhat.com>
+
+	PR c++/94477
+	* pt.c (tsubst_expr) <case OMP_MASTER>: Clear
+	omp_parallel_combined_clauses.
+
 	2020-03-30  Jakub Jelinek  <jakub@redhat.com>
 
 	PR c++/94385
diff --git a/gcc/cp/pt.c b/gcc/cp/pt.c
index bc572ac51fb..7f51f70c71a 100644
--- a/gcc/cp/pt.c
+++ b/gcc/cp/pt.c
@@ -17882,8 +17882,10 @@ tsubst_expr (tree t, tree args, tsubst_flags_t complain, tree in_decl,
       add_stmt (t);
       break;
 
-    case OMP_SECTION:
     case OMP_MASTER:
+      omp_parallel_combined_clauses = NULL;
+      /* FALLTHRU */
+    case OMP_SECTION:
       stmt = push_stmt_list ();
       RECUR (OMP_BODY (t));
       stmt = pop_stmt_list (stmt);
diff --git a/gcc/testsuite/ChangeLog b/gcc/testsuite/ChangeLog
index 963a1af39be..306380907ee 100644
--- a/gcc/testsuite/ChangeLog
+++ b/gcc/testsuite/ChangeLog
@@ -1,6 +1,11 @@
 2020-04-07  Jakub Jelinek  <jakub@redhat.com>
 
 	Backported from mainline
+	2020-04-04  Jakub Jelinek  <jakub@redhat.com>
+
+	PR c++/94477
+	* g++.dg/gomp/pr94477.C: New test.
+
 	2020-04-03  Jakub Jelinek  <jakub@redhat.com>
 
 	PR target/94460
diff --git a/gcc/testsuite/g++.dg/gomp/pr94477.C b/gcc/testsuite/g++.dg/gomp/pr94477.C
new file mode 100644
index 00000000000..e7fdc23d6d3
--- /dev/null
+++ b/gcc/testsuite/g++.dg/gomp/pr94477.C
@@ -0,0 +1,18 @@
+// PR c++/94477
+// { dg-do compile }
+
+void foo ();
+
+template <int>
+void
+bar ()
+{
+  #pragma omp parallel master
+  foo ();
+}
+
+void
+baz ()
+{
+  bar<0> ();
+}

